// NetWorkCompsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NetWorkComps.h"
#include "NetWorkCompsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNetWorkCompsDlg dialog

CNetWorkCompsDlg::CNetWorkCompsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNetWorkCompsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNetWorkCompsDlg)
	m_pImageList = NULL;
	m_strTitle = _T ("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNetWorkCompsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNetWorkCompsDlg)
	DDX_Control(pDX, IDC_COMPNAME_TREE, m_ctrlCompNameTree);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNetWorkCompsDlg, CDialog)
	//{{AFX_MSG_MAP(CNetWorkCompsDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED (ID_NETCOMPS_BUTTON, OnNetworkCompButton)
	ON_BN_CLICKED (ID_NETPRINTERS_BUTTON, OnNetworkPrintersButton)
	ON_BN_CLICKED (ID_RECYCLE_BUTTON, OnRecycleBinButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNetWorkCompsDlg message handlers

BOOL CNetWorkCompsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strMenu;
		strMenu.LoadString(IDS_ABOUTBOX);
		if (!strMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			strMenu.LoadString(IDS_ABOUTBOX);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	if (m_ToolBar.Create (this)) {
		m_ToolBar.LoadBitmap (IDR_DLG_TOOLBAR);
		
		// We need to resize the dialog to make room for control bars.
		// First, figure out how big the control bars are.

		CRect rcClientStart;
		CRect rcClientNow;
		GetClientRect (rcClientStart);
		RepositionBars (AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST,
                  0, reposQuery, rcClientNow);

		// Move all the controls in dialog to account for space used by control bars at the
		// top or left of the client area. If dialog contains a menu, you also need to account
		// for the space used by the menu.

		CPoint ptOffset (rcClientStart.left - rcClientNow.left,
			rcClientStart.top - rcClientNow.top);

		ptOffset.y += (2 * ::GetSystemMetrics(SM_CYEDGE));

		CRect rcChild;
		CWnd *pWndChild = GetWindow (GW_CHILD);
		while (pWndChild != NULL) {
			pWndChild->GetWindowRect (rcChild);
			rcChild.OffsetRect (ptOffset);
			pWndChild->MoveWindow (rcChild);
			pWndChild = pWndChild->GetNextWindow ();
		}

		// Increase the dialog window dimensions by the amount of space used by the control bar.
		
		CRect rcDlg;
		GetWindowRect (rcDlg);
		rcDlg.right += rcClientStart.Width () -  rcClientNow.Width ();
		rcDlg.bottom += rcClientStart.Height () -  rcClientNow.Height ();

		MoveWindow (rcDlg, FALSE);

		// Position the control bars using RepositionBars(). 
		m_ToolBar.LoadToolBar (IDR_DLG_TOOLBAR);
		m_ToolBar.SetBarStyle(m_ToolBar.GetBarStyle() | CBRS_TOOLTIPS);
		RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNetWorkCompsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNetWorkCompsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNetWorkCompsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CNetWorkCompsDlg::OnNetworkCompButton() 
{
	CShellExt shellExt;

	if ((m_pFolderItemLst = shellExt.GetCompsOnNetwork ()) == NULL) {
		return;
	}

	m_strTitle = _T ("Network Compueters");

	SetTreeInformation ();
}

void CNetWorkCompsDlg::OnNetworkPrintersButton() 
{
	CShellExt shellExt;

	if ((m_pFolderItemLst = shellExt.GetPrintersOnNetwork ()) == NULL) {
		return;
	}

	m_strTitle = _T ("Network Printers");

	SetTreeInformation ();
}

void CNetWorkCompsDlg::OnRecycleBinButton() 
{
	CShellExt shellExt;

	if ((m_pFolderItemLst = shellExt.GetRecycleBinItems ()) == NULL) {
		return;
	}

	m_strTitle = _T ("Recycle Bin");

	SetTreeInformation ();
}

void CNetWorkCompsDlg::SetTreeInformation ()
{
	FOLDERITEM folderItem;

	TV_INSERTSTRUCT insertStruct;
	insertStruct.hParent = NULL;
	insertStruct.hInsertAfter = TVI_SORT;

	if (m_pImageList != NULL) {
		delete m_pImageList;
		m_pImageList = NULL;
	}

	m_pImageList = new CImageList();
	m_pImageList->Create(16, 16, TRUE/*bMask*/, 6, 4);
	m_ctrlCompNameTree.SetImageList(m_pImageList, TVSIL_NORMAL);

	m_ctrlCompNameTree.DeleteAllItems ();

	HTREEITEM parentItem = m_ctrlCompNameTree.InsertItem ((LPCTSTR)m_strTitle);

	POSITION pos = m_pFolderItemLst->GetHeadPosition ();
	while (pos != NULL) {
		int index = -1;
		CString str = _T ("");
		folderItem = m_pFolderItemLst->GetNext (pos);
		str = folderItem.strFolderName;
		index = m_pImageList->Add (folderItem.hIconSmall);
		insertStruct.item.mask = TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_TEXT;
		insertStruct.hParent = parentItem;
		insertStruct.item.iImage = index;
		insertStruct.item.iSelectedImage = index;
		insertStruct.item.pszText = str.GetBuffer (str.GetLength () + 1);
		m_ctrlCompNameTree.InsertItem (&insertStruct);
	}

	m_ctrlCompNameTree.Expand (parentItem, TVE_EXPAND);
}

void CNetWorkCompsDlg::PostNcDestroy() 
{
	if (m_pImageList != NULL) {
		delete m_pImageList;
		m_pImageList = NULL;
	}

	CDialog::PostNcDestroy();
}
