// NetWorkCompsDlg.h : header file
//

#if !defined(AFX_NETWORKCOMPSDLG_H__C350E04A_0A27_11D3_8135_00105AC8B8F6__INCLUDED_)
#define AFX_NETWORKCOMPSDLG_H__C350E04A_0A27_11D3_8135_00105AC8B8F6__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "DlgToolbar.h"

/////////////////////////////////////////////////////////////////////////////
// CNetWorkCompsDlg dialog

class CNetWorkCompsDlg : public CDialog
{
// Construction
public:
	CNetWorkCompsDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CNetWorkCompsDlg)
	enum { IDD = IDD_NETWORKCOMPS_DIALOG };
	CTreeCtrl	m_ctrlCompNameTree;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNetWorkCompsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CImageList *m_pImageList;
	CString m_strTitle;
	CDlgToolbar m_ToolBar;
	const FolderItemList *m_pFolderItemLst;

	// Generated message map functions
	//{{AFX_MSG(CNetWorkCompsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnNetworkCompButton ();
	afx_msg void OnNetworkPrintersButton ();
	afx_msg void OnRecycleBinButton ();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	void SetTreeInformation ();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NETWORKCOMPSDLG_H__C350E04A_0A27_11D3_8135_00105AC8B8F6__INCLUDED_)
